# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ WEB PATIO : init.cgi - 2022/03/26
#│ copyright (c) kentweb, 1997-2022
#│ https://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'WebPatio v6.1';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトはフリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│ WebPatio v6.1 View Limit : patio.cgi - 2023/10/07
#│ Edited by TRANSFORM Since 2012
#│ https://www.transformsite.com/
#└─────────────────────────────────

#===========================================================
# ■ 基本設定
#===========================================================

# アクセス制限をする
# 0=no 1=yes
$cf{authkey} = 1;

# ログイン有効期間（分）
$cf{authtime} = 60;

# 画像アップを許可する
# 0=no 1=yes
$cf{image_upl} = 1;

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 0;

# トリップ機能（ハンドル偽造防止）のための変換キー
# →　英数字で2文字
$cf{trip_key} = 'ab';

# タイトル
$cf{bbs_title} = "WebPatio v6.1 View Limit";

# 掲示板本体CGI【URLパス】
$cf{bbs_cgi} = './patio.cgi';

# 掲示板投稿CGI【URLパス】
$cf{regist_cgi} = './regist.cgi';

# 掲示板管理CGI【URLパス】
$cf{admin_cgi} = './admin.cgi';

# 認証管理プログラム【サーバパス】
$cf{session_pl} = './lib/session.pl';

# 現行ログindex【サーバパス】
$cf{nowfile} = './data/index1.log';

# 過去ログindex【サーバパス】
$cf{pastfile} = './data/index2.log';

# 会員ファイル【サーバパス】
$cf{memfile} = './data/memdata.cgi';

# 記録ファイルディレクトリ【サーバパス】
$cf{logdir} = './data/log';

# セッションディレクトリ【サーバパス】
$cf{sesdir} = './data/ses';

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = './tmpl';

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# アイコン【URLパス】
# → 順に [ホームページ][YouTube]
$cf{ico_home} = "./cmn/icon/home.png";
$cf{tube_ico} = "./cmn/tube_icon.png";

# ミニカウンタの設置
# → 0=no 1=テキスト 2=画像
$cf{counter} = 1;

# ミニカウンタの桁数
$cf{mini_fig} = 6;

# テキストのとき：ミニカウンタの色
$cf{cntcol} = "#fff";

# カウンタファイル【サーバパス】
$cf{cntfile} = './data/count.dat';

# 画像のとき：画像ディレクトリを指定【URLパス】
# → 最後は必ず / で閉じない
$cf{gif_path} = "./cmn/img";

# YouTubeを表示する
$cf{tube} = 1;

# 文字コード自動変換を行う (0=no 1=yes)
# → ブラウザは本体の文字コードで投稿するはずなので通常は「0」でOK
$cf{chg_code} = 0;

# 戻り先【URLパス】
$cf{homepage} = '../index.html';

# 記事にNEWマークを付ける時間（時間単位）
$cf{new_time} = 24;

# NEWマークの表示形態
#  → テキスト表示の場合には $cf{new_mark} = '<font color="#e29399">new!!!</font>';
$cf{new_mark} = '<img src="./cmn/new.gif" alt="New Mark" title="New Mark" class="icon">';

# 文字色の設定
# →　スペースで区切る
$cf{colors} = '#000000 #C0C0C0 #666666 #80B3DE #398ED9 #8d93c8 #6c2463 #a688bd #98605e #ea5550 #da81b2 #e3acae #ffdc00 #f39800 #79c06e #417038';

# アイコンディレクトリ【URLパス】
$cf{iconurl} = './cmn/icon';

# 顔文字ディレクトリ【URLパス】
$cf{emoticonurl} = './emoticons';

# アイコン定義
# → 拡張子とファイル名のペア
$cf{icons} = {
	'.pdf'  => 'pdf.png',
	'.doc'  => 'word.png',
	'.docx' => 'Word-icon.png',
	'.xls'  => 'excel.png',
	'.xlsx' => 'Excel-icon.png',
	'.ppt'  => 'ppt.png',
	'.pptx' => 'PowerPoint-icon.png',
	'.txt'  => 'text.png',
	'.zip'  => 'zip.png',
	'.mp3'  => 'mp3.png',
	'.mp4'  => 'mp4.png',
	};

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_text}  = 1;  # TEXT
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_png}   = 1;  # PNG
$cf{ok_excel} = 1;  # EXCEL
$cf{ok_word}  = 1;  # WORD
$cf{ok_ppt}   = 0;  # POWER POINT
$cf{ok_zip}   = 1;  # ZIP
$cf{ok_pdf}   = 1;  # PDF
$cf{ok_mp3}   = 1;  # mp3
$cf{ok_mp4}   = 1;  # MP4

# 画像ディレクトリ（画像アップを許可するとき）
# → 順に、サーバパス、URLパス
$cf{upldir} = './upl';
$cf{uplurl} = './upl';

# 画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 200;	# 横幅
$cf{max_img_h} = 150;	# 縦幅

# 現行ログ最大スレッド数
# → これを超えると過去ログへ移動
$cf{i_max} = 100;

# 過去ログ最大スレッド数
# → これを超えると自動削除
$cf{p_max} = 300;

# 返信記事の表示順 (0=降順{desc} 1=昇順{asc})
$cf{asc_order} = 0;

# 1スレッド当りの「表示」記事数
# → 順に、スレッド表示、アルバム表示
# sample用に小さい値を設定してあるので、適宜修正して下さい
$cf{pg_max} = 3;
$cf{max_albums} = 5; #固定

# 1スレッド当りの「最大」記事数
# → これを超えると過去ログへ廻ります
# → 残り90%でアラームを表示
$cf{m_max} = 20;

# 現行ログ初期メニューのスレッド表示数
$cf{pgmax_now} = 10;

# 過去ログ初期メニューのスレッド表示数
$cf{pgmax_past} = 20;

# コメント入力文字数（全角換算）
$cf{max_msg} = 3000;

# URLの自動リンク (0=no 1=yes)
$cf{autolink} = 1;

# スマイルアイコン(SCEditer内包のスマイルアイコン使用のため下記は未使用)
# → スペースで区切る
$cf{smile} = 'sml_cool.gif sml_sml.gif sml_yawn.gif sml_q.gif sml_big.gif sml_shm.gif sml_wink.gif sml_cry.gif sml_roll.gif sml_bonk.gif';

# メール送信
# 0 : しない
# 1 : スレッド生成時
# 2 : 投稿記事すべて
$cf{mailing} = 0;

# メール送信先
$cf{mailto} = 'xxx@xxx.xx';

# sendmailパス
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# アクセス制限（半角スペースで区切る、アスタリスク可）
#  → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{deny_host} = '';
#  → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
$cf{deny_addr} = '';

# 記事の更新は method=POST 限定 (0=no 1=yes)
# （セキュリティ対策）
$cf{postonly} = 1;

# 連続投稿の禁止時間（秒）
$cf{wait} = 0;

# 禁止ワード
# → 投稿時禁止するワードをコンマで区切る
$cf{no_wd} = '';

# 日本語チェック（投稿時日本語が含まれていなければ拒否する）
# 0=No  1=Yes
$cf{jp_wd} = 0;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値
$cf{urlnum} = 2;

# １回当りの最大投稿サイズ (bytes)
# → 例 : 102400 = 100KB
$cf{maxdata} = 512000000;

# クッキーID名（特に変更しなくてよい）
$cf{cookie_id} = "web_patio";

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードのロック期間：自動解除を日数で指定
# → この値を 0 にすると自動解除しません。
$cf{lock_days} = 14;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 2;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captchapatio';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "wild_woods.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "tempest.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# フォルダーアイコン
$cf{fld_icon} = {
	0 => 'fld_lock.png',
	1 => 'fld_nor.png',
	2 => 'fld_alert.png',
	3 => 'fld_key.png',
	alerm => 'fld_alarm.png',
	image => 'fld_img.png',
	tube => 'fld_tube.png',
	};

# 設定内容を返す
sub set_init {
	return %cf;
}

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if (!/^upfile\d$/) {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行変換
			$val =~ s/\r\n/<br>/g;
			$val =~ s/\n/<br>/g;
			$val =~ s/\r/<br>/g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/patio.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/patio-mobile.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
	- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
	++ <a href="http://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  画像リサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}


1;

